*-- CORE.PRG
*--
*-- Main program for application
*-- 
*--
set bell off 
set clock off
SET COMPATIBLE off
SET DEBUG ON
set deleted on
set echo off
set escape off
set exclusive off
set near on
set refresh to 0,300
set resource off
set safety off
set scoreboard off 
set status off  
set sticky on
set talk off  

set function "F2" to ""
set function "F3" to ""
set function "F4" to ""
set function "F5" to ""
set function "F6" to ""
set function "F7" to ""
set function "F8" to ""
set function "F9" to ""
set function "F10" to ""

*-- Global logical variables
gl_adding  = .f.	&& used for variables that can only be manipulated only once such as ID's.
gl_allocat = .f.    && True means this brows item can be broken down into a deeper list
gl_beep    = .t.	&& beep is on in warnings
gl_browsin = .f.	&& lets me know if a browse is active
gl_editing = .f.	&& if .t. then a file is open for editing, viewing, or adding
gl_false   = .f.	&& False
gl_found   = .f.	&& holds results of seeks or locates
gl_filtnon = .f.	&& When .t. states which fiter is active
gl_filtsim = .f.	&& Simple filter expression
gl_filtadv = .f.	&& Advanced filter expression
gl_hdline  = .f.	&& If true don't allow Table view option
					&& used for header/line item tables
gl_linebro = .f.	&& Blanks out "Order", "SEEK" when browsing in detail of header/detail screens
gl_oktopri = .f.	&& Tells me if its ok to print a report
gl_oktoadd = .t.    && Says if records can be added
gl_online  = .f.	&& Required for modem menu
gl_quiting = .f.	&& close all files and return to dos
gl_true    = .t.	&& True
gl_release = .t.	&& If a dialog box gets popped up it shouldn';t 
					&& deactivate menu options etc. in the li_reclose module
gl_switch  = .t.    && Global toggle switch, change from false to true and back

*-- Global character variables

gc_bralias = ""				&& Alias name of file for browse window
gc_brotitl = ""				&& Title of browse window
gc_char    = ""				&& general purpose variable
gc_fldname = ""				&& Used in Seek as a field name that describes the key
gc_default = ""
gc_dest    = "Printer"			&& States where reports are generated
gc_firstob = ""				&& States which object is first in read for show gets
gc_filtexp = ""				&& This is the filter exprssion
gc_getcolr = ",GR+/N"		&& Color of active gets variables
gc_getstat = ""				&& Color when get active but not selected
gc_getacti = ""				&& Color when get acitve and selected
gc_key	   = ""				&& Used in Seek as the key field to seek on
gc_nocolor = ""				&& Say color that displays blank on screen
gc_message = ""				&& message to be displayed when needed.
gc_nxtproc = ""     			&& next procedure
gc_resourc = "LI_STAT.DBF"		&& system resource file
gc_path    = ""
gc_proc    = ""				&& name of currently executing procedure
gc_report  = ""				&& Global report name
gc_saycolr = ",W+/N"		&& Say color of gets when not editing
gc_seekmsg = ""				&& Used in Seek as the field to lookup in the message list
gc_tempf01 = "00000001.DBF"	&& Temporary file name
gc_tmppath = "G:\"
gc_wintitl = ""				&& Name of browse display window

gn_close   = 0	
gn_recno   = 1		&& record number set to top of file

*--	Keyboard input
gk_down    = 24
gk_delete  = 7
gk_esckey  = 27      
gk_enter   = 13
gk_endkey  = 6      
gk_homekey = 1      
gk_insert  = 22
gk_left    = 19 
gk_mouse   = 115
gk_pgdn    = 3      
gk_pgup    = 18      
gk_readky  = 1
gk_right   = 4 
gk_space   = 32
gk_up      = 5

dime ga_tagname[ 3 ]		&& Used to hold the tag names for each table
store "" to ga_tagname

*-- Disable function keys
gk_f2      = -1 
gk_f3      = -2 
gk_f4      = -3 
gk_f5      = -4 
gk_f6      = -5 
gk_f7      = -6
gk_f8      = -7
gk_f9      = -8

*-- Date variables
gd_blank   = {"  /  /  "}	&& overall blank date

*-- Define system colors and border strings
gc_backcol = "N/BU"

*-- Set up path and environment information
set procedure to library
*on error do errproc with error(),message(),message(1),sys(16),date()

gc_path = sys(5) + sys(2003)
set default to ( gc_path )
gc_path = gc_path + ";" ;
        + gc_path + "\DATA;" ;
        + gc_path + "\SCREEN;" ;
        + gc_path + "\MENU;" ;
        + gc_path + "\REPORT"

set path to (gc_path)

activate screen

*--
*-- Determine the attributes of the blank out color set for read show
*-- routines for say fields
*--

lc_scheme1 = scheme(1)
lc_say     = scheme( 1,1 )
lc_back    = substr( lc_say, at( "/", lc_say) + 1 )
gc_nocolor = lc_back + "/" + lc_back + ;
              substr( lc_scheme1, at( ",", lc_scheme1 ) )
gc_getstat =  scheme(1,2) + "," + scheme(1,2)	&& Color when get acitve but not selected
gc_getacti =  scheme(1,2) + "," + scheme(1,6)	&& Color when get acitve and selected


*-- Define global border settings for windows
*-- Define windows in screen set ups using single line borders
*--
SET BORDER TO chr(205), chr(205), chr(179), chr(179), ;
              chr(254), chr(184), chr(212), chr(190), ;
              chr(46), chr(46), chr(46), chr(46), ;
              chr(46), chr(46), chr(46), chr(46)

on key label F1 HELP

set sysmenu to 
do mainmenu.mpr
set sysmenu automatic

read valid mainhand()

set sysmenu to default
close databases
cancel
quit


procedure mainhand
private m.temp
*-- Global variable that tells me to quit
if gl_quiting
 return .t.
endif

* now see what application the user wants to start

IF LEN(gc_nxtproc) > 0		  && Launches an SPR which was
   m.temp = gc_nxtproc		  && specified from the menu
   gc_nxtproc = ""
   DO (m.temp)
   RETURN .F.
ENDIF

* the following is required when clicking on other windows

DO CASE						  		&& Handles all other cases

ENDCASE
 
return .f.